package
{
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU; 
	import flash.geom.Point;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/tile.png")] public static var TilePics:Class;
		[Embed(source = "data/level1.txt", mimeType="application/octet-stream")] public static var Level1:Class;
//		[Embed(source = "data/bg.png")] private var BgImg:Class;
//		[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		[Embed(source = "data/awefvawefvwef.mp3")] public static var SndMusic:Class;
//		[Embed(source = "data/sound.mp3")] public static var SndSound:Class;
//		[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;

		public var player:Player;
		public var flowers:FlxGroup;
		public var endDoor:EndDoor;
		public var openflowers:FlxGroup;
		public var others:FlxGroup;
		public var tilemap:FlxTilemap;
		
		override public function create():void
		{
			var levelStr:String = new Level1;
			var tarray1:Array = levelStr.split("\n");
			var tarray2:Array = new Array();
			for (var i:int=0;i<tarray1.length;i++)
			{
				tarray2.push(tarray1[i].split(","));
			}
			var oldString:String="";
			while (oldString!=levelStr)
			{
				oldString=levelStr;
				levelStr=levelStr.replace("3","0");
			}
			oldString="";
			while (oldString!=levelStr)
			{
				oldString=levelStr;
				levelStr=levelStr.replace("4","0");
			}
			
			oldString="";
			while (oldString!=levelStr)
			{
				oldString=levelStr;
				levelStr=levelStr.replace("5","0");
			}
			
			oldString="";
			while (oldString!=levelStr)
			{
				oldString=levelStr;
				levelStr=levelStr.replace("6","0");
			}
			
			oldString="";
			tilemap = new FlxTilemap();
			trace("TILE MAP : " + levelStr);
			tilemap.loadMap(levelStr,TilePics,19,28);
			tilemap.collideIndex=2;
			this.add(tilemap);
			
			flowers = new FlxGroup();
			this.add(flowers);
			
			openflowers = new FlxGroup();
			this.add(openflowers);
			
			others = new FlxGroup();
			this.add(others);			
			
			
			for (i=0;i<tarray2.length;i++)
			{
				for (var j:int=0;j<tarray2[i].length;j++)
				{
					switch (tarray2[i][j])
					{
						case "1":
							
							break;
						case "3":
							player = new Player(j*19,i*28);
							this.add(player);
							FlxG.follow(player);
							FlxG.followBounds(0,0,100000,20*28);
							break;
						case "4":
							var fl:Flower = new ClosedFlower(j*19,i*28);
							flowers.add(fl);
							break;
						case "5":
							var oth:Other = new Other(j*19,i*28);
							others.add(oth);
							break;
						case "6":
							endDoor = new EndDoor(j*19,i*28);
							this.add(endDoor);
							break;
					}
				}
			}						
			//player = new Player();
		}
		
		public function collectFlower(p:FlxSprite,f:FlxSprite):void
		{
			var _p:Player = p as Player;
			if (_p.hasFlower==false)
			{
				_p.hasFlower=true;
				_p.play("idleflower",true);
				f.kill();
			}
			
		}
		
		public function overlapOther(p:FlxSprite,o:FlxSprite):void
		{
			var _p:Player = p as Player;
			if (_p.hasFlower==true)
			{				
				_p.hasFlower=false;
				_p.play("idle",true);
				o.solid=false;
				o.play("bop",true);
				var openfl:OpenFlower = new OpenFlower(o.x+9,o.y);
				openflowers.add(openfl);
			}
			
		}
		
		override public function update():void
		{
			FlxU.overlap(player,flowers,collectFlower);
			if (player.hasFlower)
			{
				FlxU.overlap(player,others,overlapOther);
			}
			FlxU.collide(player,tilemap);
			FlxU.collide(player,openflowers);
			super.update();
			
			if (player.overlaps(endDoor))
			{
				FlxG.state = new EndState();
			}
			
			if (player.y>20*28)
			{
				FlxG.state = new GameState();
			}
		}
	}
}