package
{
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	
	public class Player extends FlxSprite
	{
		[Embed(source = "data/player.png")] public static var Image:Class;
		public function Player(X:Number, Y:Number)
		{
			super(X, Y, null);
			this.loadGraphic(Image,true,true,19,28);
			this.addAnimation("idle",[0],2);
			this.addAnimation("walk",[1,0],4);
			this.addAnimation("jump",[1],2);
			this.addAnimation("postrate",[2,3],4);
			this.addAnimation("fellate",[4,5],3);
			this.addAnimation("idleflower",[6,7],4);
			this.addAnimation("walkflower",[8,6],4);
			this.addAnimation("jumpflower",[8],4);
			this.play("bop");	
			this.solid=true;
			this.maxVelocity.x=80;
			this.maxVelocity.y=200;
			this.acceleration.y=300;
			hasFlower=false;
			jumping=false;
		}
		public var jumping:Boolean;
		public var hasFlower:Boolean;
		
		override public function update():void
		{
			var toPlay:String;
			if (hasFlower)
				toPlay="idleflower";
			else
				toPlay="idle";
			
			velocity.x=velocity.x*0.9;
			
			if (FlxG.keys.LEFT)
			{
				if (this.hasFlower)
				{
					toPlay="walkflower";
				}
				else
				{
					toPlay = "walk";
				}
				this.facing=FlxSprite.LEFT;
				velocity.x-=10;
			}
			if (FlxG.keys.RIGHT)
			{
				if (this.hasFlower)
				{
					toPlay="walkflower";
				}
				else
				{
					toPlay = "walk";
				}
				this.facing=FlxSprite.RIGHT;
				velocity.x+=10;
			}
			if (FlxG.keys.justPressed("X") || FlxG.keys.justPressed("UP"))
			{
				if (Math.abs(this.velocity.y)<0.1)
				{
					this.velocity.y=-150;
					jumping=true;
				}
			}
			
			if (jumping&&Math.abs(this.velocity.y)<0.1)
			{
				jumping=false;
			}
			
			if (jumping)
			{
				if (hasFlower)
				{
					toPlay="jumpflower";
				}
				else
				{
					toPlay="jump";					
				}
			}
			this.play(toPlay);
			
			super.update();
		}
	}
	
}